WebMvc/WebMvc/urls.py
from django.contrib import admin
from django.urls import path
from django.urls.conf import include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('example/', include('example.urls', namespace='example')),
    path('', include('store.urls', namespace='store')),
]

WebMvc/example/urls.py
from django.conf.urls import url
from django.urls import path

from . import view

app_name = 'example'
urlpatterns = [
    url(r'^$', view.index)
]

WebMvc/store/urls.py
from django.conf.urls import url
from django.urls import path

from . import views

app_name = 'store'
urlpatterns = [
    path('', views.index, name='list'),
    path('add', views.insertComposer, name='add'),
    path('details/<int:id>/', views.composerDetails, name='details'),
    path('details2', views.composerDetails2, name='details2'),
]

WebMvc/store/models.py
from django.db import models

class Composer(models.Model):
    lastname = models.CharField(max_length=40, null=False)
    firstname = models.CharField(max_length=40, null=False)
    
    def __str__(self) -> str:
        return self.lastname + " " + self.firstname
    
class Compilation(models.Model):
    title = models.CharField(max_length=50)
    artists = models.ManyToManyField(Composer, related_name='album', blank=True)

WebMvc/store/forms.py
from django.forms import ModelForm, TextInput, fields
from .models import Composer
from django.forms.utils import ErrorList

class ComposerForm(ModelForm):
    class Meta:
        model = Composer
        fields = ["lastname", "firstname"]
        widgets = {
            'lastname': TextInput(attrs={ 'class': 'form-control' }),
            'firstname': TextInput(attrs={ 'class': 'form-control' }),
        }
        
class ParagraphErrorList(ErrorList):
    def __str__(self) -> str:
        return self.asDiv()
    
    def asDiv(self):
        if not self:
            return ''
        
        return "<div class='text-danger'>%s</div>" % ''.join(['<p class="small text-danger">%s</p>' % e for e in self])

WebMvc/store/views.py
from django.http import HttpResponse
from django.shortcuts import redirect, render, get_object_or_404
from django.template import loader
from django.core.paginator import Paginator, PageNotAnInteger, EmptyPage
from django.db import transaction, IntegrityError

from .forms import ComposerForm

from .models import Composer

def index(request):
    composers = Composer.objects.all()
    paginator = Paginator(composers, 5)
    page = request.GET.get('page')
    max_page = paginator.num_pages
    try:
        composer_list = paginator.page(page)
        current_page = int(page)
    except PageNotAnInteger:
        composer_list = paginator.page(1)
        current_page = 1
    except EmptyPage:
        composer_list = paginator.page(paginator.num_pages)
        current_page = paginator.num_pages
    
    pages = []
    for i in range(int(current_page), max_page +1):
        pages.append(i)
    
    context = {
        'composers': composer_list,
        'pages': pages
    }
    return render(request, 'store/index.html', context=context)

@transaction.atomic
def insertComposer(request):
    context = {}
    if request.method == "POST":
        form = ComposerForm(request.POST)
        if form.is_valid():
            composer = form.save(commit=False)
            composer.save()
            
            return redirect('/')
        else:
            context['errors'] = form.errors.items()
    return render(request, 'store/composerForm.html', context=context)

@transaction.atomic
def composerDetails(request, id):
    composer = get_object_or_404(Composer, pk=id)
    context = {}
    context['composer'] = composer
    
    return render(request, 'store/details.html', context=context)

@transaction.atomic
def composerDetails2(request):
    id = request.GET.get('query')
    composer = get_object_or_404(Composer, pk=id)
    context = {}
    context['composer'] = composer
    
    return render(request, 'store/details.html', context=context)

WebMvc/example/templates/index.html
<h1>HELLO!!!!</h1>

WebMvc/store/templates/store/base.html
<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">
        <title>Mon site</title>

        {% load static %}
        <link rel="stylesheet" type="text/css" href="{% static 'store/css/bootstrap.min.css' %}"/>
    </head>
    <body>
    <div class="container">
        <nav class="navbar navbar-expand-lg navbar-light bg-light">
            <a class="navbar-brand" href="#">Navbar</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
                <div class="collapse navbar-collapse" id="navbarNav">
                    <ul class="navbar-nav">
                    <li class="nav-item active">
                        <a class="nav-link" href="{% url 'store:list' %}">Home <span class="sr-only">(current)</span></a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'store:add' %}">Add composer</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="#">Pricing</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link disabled" href="#">Disabled</a>
                    </li>
                    </ul>
                </div>
            </nav>
        {% block content %}{% endblock %}
        <script src="{% static 'store/js/jquery-3.6.0.min.js' %}"></script>
        <script src="{% static 'store/js/bootstrap.min.js' %}"></script>
    </div>
    </body>
</html>

WebMvc/store/templates/store/composerForm.html
{% extends 'store/base.html' %}

{% block content %}
<form class='form-group' action='{% url 'store:add' %}' method='post'>
    {% csrf_token %}
    <div class='form-group'>
        <label for="lastname">
            Lastname
        </label>
        <input type="text" name="lastname" id="lastname" placeholder="Lastname" >
    </div>

    <div class='form-group'>
        <label for="firstname">
            Firstname
        </label>
        <input type="text" name="firstname" id="firstname" placeholder="Firstname" >
    </div>
    <button class='btn btn-primary' type="submit">Save</button>
</form>
{% if errors %}
    <div>
        {% for key, error in errors %}

        {% autoescape off %}
            {{ key }} {{ error }}
        {% endautoescape %}
        {% endfor %}
    </div>
{% endif %}
{% endblock %}

WebMvc/store/templates/store/composerList.html
{% if composers|length_is:'0' %}
    <div>
        <p>Il n'y a aucun compositeurs en db!</p>
    </div>
{% else %}
    <table class="table">
        <thead class='thead-dark'>
            <tr>
                <th>#</th>
                <th>Lastname</th>
                <th>Firstname</th>
                <th>Actions</th>
            </tr>
        </thead>
        <tbody>
            {% for composer in composers %}
            {% comment %} print(composer) {% endcomment %}
                <tr>
                    <td>{{composer.pk}}</td>
                    <td>{{composer.lastname}}</td>
                    <td>{{composer.firstname}}</td>
                    <td>
                        <a class="btn  btn-primary" href='{% url 'store:details' id=composer.pk %}'>
                            Details
                        </a>
                    </td>
                </tr>
            {% endfor %}
        </tbody>
    </table>
    <nav>
        <ul class='pagination'>
            
                <li class="page-item">
                    <a class="page-link" href='{% if composers.has_previous %} ?page={{ composers.previous_page_number }} {% else %} # {% endif %}' disabled='{% if composers.has_previous %} false {% else %} true {% endif %}'>Previous</a>
                </li>
            
            {% for i in pages %}
                <li class="page-item"><a class="page-link" href='?page={{ i }}'>{{ i }}</a></li>
            {% endfor %}
            {% if composers.has_next %}
                <li class="page-item"><a class="page-link" href='?page={{ composers.next_page_number }}'>Next</a></li>
            {% endif %}
        </ul>
    </nav>
{% endif %}

WebMvc/store/templates/store/details.html
{% extends 'store/base.html' %}

{% block content %}
{{composer}}
{% endblock %}

WebMvc/store/templates/store/index.html
{% extends 'store/base.html' %}

{% block content %}
{% include 'store/composerList.html' %}
{% endblock %}